//
//  HZWSelectTime.m
//  LoopPicker循环滚动显示数据
//
//  Created by 黄志威 on 2016/11/8.
//  Copyright © 2016年 book. All rights reserved.
//

#import "HZWSelectTime.h"

#define SCREEN_WIDTH [[UIScreen mainScreen] bounds].size.width
#define SCREEN_HEIGHT [[UIScreen mainScreen] bounds].size.height

#define VIEW_WIDTH self.frame.size.width
#define VIEW_HEIGHT self.frame.size.height

#define HOUR @"时"
#define MINUTE @"分"
#define SECOND @"秒"

@implementation HZWSelectTime

+(instancetype)datePickerViewWithdDelegate:(id)delegate
{
    
    HZWSelectTime *selectTime = [[HZWSelectTime alloc] initWithFrame:[UIScreen mainScreen].bounds andDelegate:delegate];
    return selectTime;
}

-(instancetype)initWithFrame:(CGRect)frame andDelegate:(id)delegate
{
    if (frame.size.width>frame.size.height) {
        float a = frame.size.height;
        frame.size.height = frame.size.width;
        frame.size.height = a;
    }
    self = [super initWithFrame:frame];
    if (self) {
        self.backgroundColor = [[UIColor grayColor] colorWithAlphaComponent:0.8];
        self.delegate = delegate;
        [self initialzationPickerView];
        [self initializationTopView];
        _hoursArray = [[NSArray alloc] initWithObjects:@"00",@"01",@"02",@"03",@"04",@"05",@"06",@"07",@"08",@"09",@"10",@"11",@"12",@"13",@"14",@"15",@"16",@"17",@"18",@"19",@"20",@"21",@"22",@"23",nil];
        _minuteArray2 = [[NSArray alloc] initWithObjects:@"00",@"01",@"02",@"03",@"04",@"05",@"06",@"07",@"08",@"09",@"10",@"11",@"12",@"13",@"14",@"15",@"16",@"17",@"18",@"19",@"20",@"21",@"22",@"23",@"24",@"25",@"26",@"27",@"28",@"29",@"30",@"31",@"32",@"33",@"34",@"35",@"36",@"37",@"38",@"39",@"40",@"41",@"42",@"43",@"44",@"45",@"46",@"47",@"48",@"49",@"50",@"51",@"52",@"53",@"54",@"55",@"56",@"57",@"58",@"59",@"00",@"01",@"02",@"03",@"04",@"05",@"06",@"07",@"08",@"09",@"10",@"11",@"12",@"13",@"14",@"15",@"16",@"17",@"18",@"19",@"20",@"21",@"22",@"23",@"24",@"25",@"26",@"27",@"28",@"29",@"30",@"31",@"32",@"33",@"34",@"35",@"36",@"37",@"38",@"39",@"40",@"41",@"42",@"43",@"44",@"45",@"46",@"47",@"48",@"49",@"50",@"51",@"52",@"53",@"54",@"55",@"56",@"57",@"58",@"59",@"00",@"01",@"02",@"03",@"04",@"05",@"06",@"07",@"08",@"09",@"10",@"11",@"12",@"13",@"14",@"15",@"16",@"17",@"18",@"19",@"20",@"21",@"22",@"23",@"24",@"25",@"26",@"27",@"28",@"29",@"30",@"31",@"32",@"33",@"34",@"35",@"36",@"37",@"38",@"39",@"40",@"41",@"42",@"43",@"44",@"45",@"46",@"47",@"48",@"49",@"50",@"51",@"52",@"53",@"54",@"55",@"56",@"57",@"58",@"59",nil];
        _minuteArray = [[NSArray alloc] initWithObjects:@"00",@"01",@"02",@"03",@"04",@"05",@"06",@"07",@"08",@"09",@"10",@"11",@"12",@"13",@"14",@"15",@"16",@"17",@"18",@"19",@"20",@"21",@"22",@"23",@"24",@"25",@"26",@"27",@"28",@"29",@"30",@"31",@"32",@"33",@"34",@"35",@"36",@"37",@"38",@"39",@"40",@"41",@"42",@"43",@"44",@"45",@"46",@"47",@"48",@"49",@"50",@"51",@"52",@"53",@"54",@"55",@"56",@"57",@"58",@"59",nil];
    }
    
    return self;
}



-(void)initialzationPickerView
{
    self.pickerView =[[UIPickerView alloc] initWithFrame:CGRectMake(0, self.frame.size.height-300, VIEW_WIDTH, 300)];
    _pickerView.delegate = self;
    _pickerView.backgroundColor = [UIColor whiteColor];
    [self addSubview:_pickerView];
    
}

-(void)initializationTopView
{
    self.topView = [[UIView alloc] initWithFrame:CGRectMake(0, VIEW_WIDTH-330, VIEW_WIDTH, 30)];
    self.topView.backgroundColor = [UIColor blackColor];
    [self addSubview:_topView];
}

-(void)show{

    
    [self addSubview:self.pickerView];
//    [[UIApplication sharedApplication].keyWindow addSubview:self];
}

#pragma mark -UIPickerViewDelegate

//列数
-(NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView
{
    return 2;
}

//每一列的行数

-(NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component
{
    switch (component) {
        case 0:
        {
            //数组个数的3倍这样可以让数据循环的显示，制造一个假象的循环
            return [_hoursArray count]*3;
        }
            break;
            case 1:
        {
            return [_minuteArray count]*3;
        }
            break;
            
        default:
            return 0;
            break;
    }
}

-(NSString *)pickerView:(UIPickerView *)pickerView titleForRow:(NSInteger)row forComponent:(NSInteger)component
{
    switch (component) {
        case 0:
        {
            NSString *str = [_hoursArray objectAtIndex:(row%[_hoursArray count])];
            NSString *returnStr = [NSString stringWithFormat:@"%@%@",str,HOUR];
            return returnStr;
        }
            break;
        case 1:{
            
            NSString *str = [_minuteArray objectAtIndex:(row%[_minuteArray count])];
            NSString *returnStr = [NSString stringWithFormat:@"%@%@",str,MINUTE];
            return returnStr;
        }
            break;
            
        default:
            return 0;
            break;
    }

}

-(void)pickerView:(UIPickerView *)pickerView didSelectRow:(NSInteger)row inComponent:(NSInteger)component
{
    
    NSInteger hourSelectedRow;
//    NSInteger minuteSelectedRow;
    NSInteger max =0 ;
    NSInteger max1 = 0;
    NSInteger base = 0;
    NSInteger base1 = 0;
    if (component==0) {
        max = [_hoursArray count]*3;
        base = (max/2)-(max/2)%[_hoursArray count];
        [pickerView selectRow:[pickerView selectedRowInComponent:0]%[_hoursArray count]+base inComponent:0 animated:NO];
        hourSelectedRow = [pickerView selectedRowInComponent:0]%[_hoursArray count]+base;
        NSLog(@"hourSelectedRow:%ld",hourSelectedRow);
        
        if (hourSelectedRow < 48 && hourSelectedRow >=24) {
            NSInteger numhour = hourSelectedRow-24;
            hourSelectedRow = numhour;
            _hour = [_hoursArray objectAtIndex:numhour];
            NSLog(@"hour==%@",_hour);
        }
    }
    
    if (component==1) {
        max1 = [_minuteArray count]*3;
        base1 = (max1/2)-(max1/2)%[_minuteArray count];
        [pickerView selectRow:[pickerView selectedRowInComponent:1]%[_minuteArray count]+base1 inComponent:1 animated:NO];
        _minute = [_minuteArray2 objectAtIndex:row];
        NSLog(@"minute===%@",_minute);
    }
    
    NSString *returnStr = [NSString stringWithFormat:@"%@%@",_hour,_minute];
    if ([self.delegate respondsToSelector:@selector(changeTime:)]) {
        [_delegate changeTime:returnStr];
    }
    
}

@end
